<template>
  <layout-page>
		<view class="pb-150">
			<view class="text-center" :class="vip ? 'vipBox' : 'avatarBox'" @tap="handleTap">
				<img :src="getUserAvatar(baseInfo?.avatar, baseInfo?.sex)" alt="" class="img-box">
				<image v-if="vip" src="/static/svg/vip.svg" class="vipIcon" @click.stop="handleToLink({path: '/pagesA/vip/index'})"></image>
				<view v-if="!useUserStore.isLogin" class="font-weight-bold font-size-20">点击登录</view>
				<view v-else class="font-weight-bold font-size-20">{{ baseInfo?.name || userInfo?.phone }}</view>
			</view>

			<view style="padding: 40rpx 0 0 0;">
				<resume-status></resume-status>
			</view>
			
			<view class="d-flex">
				<view v-for="(item, index) in itemList" :key="index" @tap="handleToLink(item)" class="parent">
					<view class="d-flex justify-space-around align-center">
						<uni-icons color="#00B760" :type="item.icon" size="30"/>
						<text class="itemText">{{ item.title }}</text>
					</view>
				</view>
			</view>
	
			<view style="height: 20rpx; background-color: #f8f8fa;"></view>
	
			<view class="card">
				<uni-list>
					<uni-list-item
						v-for="item in list"
						:clickable="true"
						:key="item.title"
						:title="item.title"
						showArrow
						:rightText="item.rightTex || ''"
						@click="handleToLink(item)"
					>
					</uni-list-item>
				</uni-list>
			</view>
	
			<button v-if="useUserStore.isLogin" class="send-button" style="margin-bottom: 50px;" @tap="handleLogout">退出登录</button>
	
			<uni-popup ref="popup" type="dialog">
				<uni-popup-dialog type="warn" cancelText="取消" confirmText="确定" title="系统提示" content="确认退出账号？" @confirm="handleLogoutConfirm"
					@close="handleLogoutClose"></uni-popup-dialog>
			</uni-popup>
			<!-- 我的分享码 -->
			<uni-popup ref="shareQrCodePopup" type="dialog">
				<view class="shareQrCodePopupContent">
					<view class="color-primary text">邀请用户注册领50积分</view>
					<view class="qrCode">
						<image
            	v-if="!!shareUrl"
							:src="shareUrl"
							:show-menu-by-longpress="true"
							style="width: 200px;height: 200px; padding: 20rpx;"
						></image>
					</view>
					<view v-if="shareUrl" class="saveImg">长按二维码保存图片</view>
				</view>
			</uni-popup>

			<uni-popup ref="inputDialog" type="dialog">
				<view class="shareQrCodePopupContent">
					<view>请前往网页版{{ dialogType ? '门墩儿招聘' : '门墩儿商城' }}</view>
					<uni-link class="ss-m-t-10" :href="dialogType ? 'https://www.menduner.com' : 'https://www.menduner.com/mall'" text="点击复制网页地址" color="#00B760" fontSize="16" copyTips="已复制，请在电脑端打开"></uni-link>
				</view>
			</uni-popup>
		</view>
	</layout-page>
</template>

<script setup>
import { ref, computed, watch } from 'vue'
import ResumeStatus from '@/components/ResumeStatus'
import { userStore } from '@/store/user'
import { getUserAvatar } from '@/utils/avatar'
import { getAccessToken, showNecessaryInfoPopup } from '@/utils/request'
import layoutPage from '@/layout'
import { showAuthModal } from '@/hooks/useModal'
import { onShow, onLoad, onShareAppMessage, onShareTimeline } from '@dcloudio/uni-app'
import { getJobAdvertisedShareQrcode } from '@/api/user'
// 设置自定义tabbar选中值
onShow(() => {
    const currentPage = getCurrentPages()[0];  // 获取当前页面实例
    const currentTabBar = currentPage?.getTabBar?.();

    // 设置当前tab页的下标index
    currentTabBar?.setData({ selected: 4 });
})

const inputDialog = ref()
const useUserStore = userStore()
const baseInfo = computed(() => useUserStore?.baseInfo)
const userInfo = computed(() => useUserStore?.userInfo)
const vip = computed(() => new Date().getTime() < useUserStore?.userInfo?.vipExpireDate)

const popup = ref()
const shareQrCodePopup = ref()
const itemList = [
	{ title: "我的关注", path: "/pagesA/collect/index", icon: "list" },
	{ title:'关注我的', path:'/pagesA/seenMe/index', icon:'staff' }
]

const defaultList = [
	{	title: '在线简历',	path: '/pagesA/resumeOnline/index'	},					
	{	title: '附件简历',	path: '/pagesA/resume/index'	},					
	// { title: '学生专区', path: '/pagesA/student/index', key: 'student', hide: false },
	{ title: '面试管理', path: '/pagesA/interview/index' },
	{	title: '会员套餐', path: '/pagesA/vipPackage/index'	},		
	// {	title: '我的分享码',	path: 'shareQrCode'	},					
	{	title: '我的分享码',	path: '/pagesB/sharePoster/index'	},					
	{	title: '新用户邀请记录',	path: '/pagesB/inviteRecord/index'	},
	{ title: '门墩儿商城', appId: 'wx6decdf12f9e7a061' },
	{ title: '我要招聘', key: 'recruit' },
	// { title: '招聘会', path: '/pagesB/jobFair/index', open: true },
	{ title: '联系我们', path: '/pagesB/contactUs/index' },
	{ title: '协议中心', path: '/pagesB/agreement/index', open: true }
]
const list = ref(defaultList.filter(e => !e.hide))

watch(
  () => baseInfo.value, 
  (newVal) => {
		if (newVal) {
			list.value = defaultList.map(e => {
				if (e?.key === 'student' && newVal.type === '1') e.hide = false // 学生信息管理。 type:0是求职者，1是学生
				return e.hide ? null : e
			}).filter(Boolean)
		}
  },
  { immediate: true },
  // { deep: true }
)

watch(
  () => vip.value, 
  (newVal) => {
		if (newVal) list.value.splice(3, 0, {	title: 'vip权益', key: 'vip',	path: '/pagesA/vip/index'	})
		else list.value = list.value.filter(e => !e.key || e.key !== 'vip')
  },
  { immediate: true },
  // { deep: true }
)

onLoad(() => {
  wx.showShareMenu({
    withShareTicket: true,
    menus: ['shareAppMessage', 'shareTimeline']
  })
  onShareAppMessage(() => {
    return {
      title: '门墩儿 专注顶尖招聘',
      path: '/pages/index/position',
			imageUrl: '../../static/img/share-poster.jpg'
    }
  })
	onShareTimeline(() => {
    return {
      title: '门墩儿 专注顶尖招聘',
      path: '/pages/index/position',
			imageUrl: '../../static/img/share-poster.jpg'
    }
  })
})

// 列表跳转
const dialogType = ref('')
const handleToLink = (item) => {
	if (item.open && item.path) return uni.navigateTo({ url: item.path })
	if (item.appId) {
		// uni.navigateToMiniProgram({
		// 	appId: item.appId,
		// })
		// return
		// uni.showToast({
		// 	title: '请前往网页版门墩儿商城',
		// 	icon: 'none'
		// })
		dialogType.value = 0
		inputDialog.value.open()
	}
	if (item.key === 'recruit') {
		// uni.showToast({
		// 	title: '请前往网页版门墩儿招聘',
		// 	icon: 'none'
		// })
		dialogType.value = 1
		inputDialog.value.open()
	}
	if (!item.path) return
  if (!getAccessToken()) {
		uni.showToast({
			title: '请先登录',
			icon: 'none'
		})
		showAuthModal()
		return
	}
  if (showNecessaryInfoPopup()) {
		uni.showToast({
			title: '请先完善基本信息',
			icon: 'none'
		})
		showAuthModal('necessaryInfo')
		return
	}
  if (item.path === 'shareQrCode') {
		handleShareCode()
		return
	}
	uni.navigateTo({
		url: item.path
	})
}

const shareUrl = ref()
// 生成分享二维码
const handleShareCode = async () => {
	const userId = useUserStore?.accountInfo?.userId || ''
	if (!userId) {
		uni.showToast({
			title: '请先登录',
			icon: 'none'
		})
		showAuthModal()
		return
	}
  if (showNecessaryInfoPopup()) {
		uni.showToast({
			title: '请先完善基本信息',
			icon: 'none'
		})
		showAuthModal('necessaryInfo')
		return
	}
	const query = {
		scene: 'shareId=' + userId,
		path: 'pages/login/index',
		width: 200,
		autoColor: false,
		checkPath: true,
		hyaline: true
	}
	const res = await getJobAdvertisedShareQrcode(query)
	shareUrl.value = res?.data ? 'data:image/png;base64,' + res.data : ''
	shareQrCodePopup.value.open()
}

// 保存到本地
// const handleSaveShareUrl = async () => {
// 	const fsm = wx.getFileSystemManager()
// 	const data = shareUrl.value
// 	if (!data) return
// 	fsm.writeFile({
// 		filePath:wx.env.USER_DATA_PATH+'/MySharingCode.png',
// 		data: data.slice(22),
// 		encoding:'base64',
// 		success: res => {
// 			wx.saveImageToPhotosAlbum({
// 				filePath: wx.env.USER_DATA_PATH + '/MySharingCode.png',
// 				success: function (res) {
// 					wx.showToast({
// 						title: '保存成功',
// 					})
// 				},
// 				fail: function (err) {
// 					console.log(err)
// 				}
// 			})
// 		}, fail: err => {
// 			console.log(err)
// 		}
// 	})
// }

// 登录
const handleTap = () => {
	if (!useUserStore.isLogin) {
		showAuthModal()
		return
	}
	uni.navigateTo({
		url: '/pagesA/resumeOnline/index'
	})
}

// 退出登录
const handleLogout = () => {
  popup.value.open()
}
const handleLogoutClose = () => {
  popup.value.close()
}
const handleLogoutConfirm = () => {
  useUserStore.handleLogout()
}
</script>

<style scoped lang="scss">
.pb-150 {
	padding-bottom: 100px;
}
.img-box {
  width: 150rpx;
  height: 150rpx;
  border: 2rpx solid #ccc;
  border-radius: 50%;
}
.vipBox {
	color: #a18a0f;
	position: relative;
	.img-box {
    border: 1px solid gold;
	}
	.vipIcon {
		position: absolute;
		width: 45px;
		height: 24px;
		bottom: 34px;
		left: 50%;
	}
}
:deep(.uni-list-item) {
	height: 120rpx !important;
	line-height: 120rpx !important;
}
:deep(.uni-list-item__content-title) {
	font-size: 32rpx !important;
	font-weight: 500;
}
.colors{
	font-size: 24rpx;
	color: #606266;
}
.size-16{
	color: #3f424f;
	font-size: 32rpx;
	margin: 13rpx 0 5rpx 0;
}
.itemText {
	color: #3f424f;
	font-size: 36rpx;
}
.parent{
	width: 50%;
	border: 1px solid #f4f4f4;
	border-radius: 10rpx;
	margin: 0 30rpx 20rpx 30rpx;
	padding: 20rpx;
}
.parent:first-child{
	margin: 0 0 20rpx 30rpx;
}
.shareQrCodePopupContent {
	width: 75vw;
	padding: 40rpx;
	margin-bottom: 20rpx;
	text-align: center;
	background-color: #fff;
	.text {
		margin-bottom: 20px;
	}
	.qrCode {
		margin-left: 4px;
	}
	.saveImg {
		text-align: center;
		margin-top: 10px;
		color: #999;
	}
}
</style>
